package core.api.models.users;

import core.entities.RoleEntity;
import core.entities.User;
import core.entities.UserRole;

public class UserInfo {

    private String username;
    private String email;
    private boolean admin;

    public UserInfo(String username, String email, boolean admin) {
        this.username = username;
        this.email = email;
        this.admin = admin;
    }

    public UserInfo(User user) {
        this.username = user.getUsername();
        this.email = user.getEmail();
        this.admin = false;
        for(RoleEntity role : user.getRoles()) {
            if(role.getName().equals(UserRole.ROLE_ADMIN)) {
                admin = true;
                break;
            }
        }
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public boolean isAdmin() {
        return admin;
    }

    public void setAdmin(boolean admin) {
        this.admin = admin;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }
}
